include masm32rt.inc
.686p
.mmx
.xmm

__KEYBDINPUT struct 
    type_       DWORD   ?
    wVk         WORD    ? 
    wScan       WORD    ? 
    dwFlags     DWORD   ? 
    time        DWORD   ? 
    dwExtraInfo DWORD   ?
    			dd 2 dup (?)
__KEYBDINPUT ends

INPUT_KEYBOARD  	EQU     1 
KEYEVENTF_KEYUP     EQU     2
KEYEVENTF_UNICODE   EQU     4

WM_ADD_DATA equ WM_USER+1

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

WND_DATA struct
	hLV				HWND  ? ; our listview
	hNextWnd		HWND  ? ; next window in clipboard viewer chain
	DaD				DWORD ?	; drag and drop = true/false
	DaD_iItem		DWORD ? ; LV-item to drag
	bLock			DWORD ? ; 
	
WND_DATA ends

CLIP_DATA struct
	pData	PVOID ?
	cb		DWORD ?
CLIP_DATA ends

.data?
	hInstance	dd ?
.code

main proc
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,WS_EX_TOPMOST,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,450,450,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

wszStrPreview proc uses edi esi ebx pwchrData: ptr WCHAR,cbData:DWORD,pwszBuffer:ptr WCHAR,ccBuffer:DWORD
	
	mov edi,pwszBuffer
	mov esi,pwchrData
	mov ebx,cbData
	shr ebx,1
	xor ecx,ecx
	dec ccBuffer
	.if ebx
		.while ecx < ebx && ecx < ccBuffer
			movzx edx,WCHAR ptr [esi+ecx*2]
			mov WCHAR ptr [edi+ecx*2],dx
			.break .if !edx
			lea ecx,[ecx+1]
		.endw
	.endif
	mov WCHAR ptr [edi+ecx*2],0
	ret
	
wszStrPreview endp

wszSendInput proc uses ebx edi esi pwszData:ptr WCHAR,cbMax:DWORD
LOCAL cc:DWORD
LOCAL cc2:DWORD
	
	mov esi,pwszData
	mov edx,cbMax
	shr edx,1
	xor ecx,ecx
	.while WCHAR ptr [esi+ecx*2] && ecx < edx
		lea ecx,[ecx+1]
	.endw
	mov cc,ecx
	mov eax,ecx
	mov edx,SIZEOF __KEYBDINPUT
	mul edx
	mov edi,alloc(ADDR [eax*2])
	push edi
	
	mov cc2,0
	xor ebx,ebx
	.while ebx < cc
		.if WCHAR ptr [esi+ebx*2] == 13 && WCHAR ptr [esi+ebx*2+2] == 10
			mov [edi].__KEYBDINPUT.type_,INPUT_KEYBOARD
			mov [edi].__KEYBDINPUT.wVk,VK_RETURN
			mov [edi].__KEYBDINPUT.wScan,0
			mov [edi].__KEYBDINPUT.dwFlags,0
			mov [edi].__KEYBDINPUT.time,0
			mov [edi].__KEYBDINPUT.dwExtraInfo,0
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.type_,INPUT_KEYBOARD
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.wVk,VK_RETURN
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.wScan,0
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.dwFlags,KEYEVENTF_KEYUP
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.time,0
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.dwExtraInfo,0
			lea ebx,[ebx+1]
		.else	
			mov [edi].__KEYBDINPUT.type_,INPUT_KEYBOARD
			mov [edi].__KEYBDINPUT.wVk,0
			mov ax,WCHAR ptr [esi+ebx*2]
			mov [edi].__KEYBDINPUT.wScan,ax
			mov [edi].__KEYBDINPUT.dwFlags,KEYEVENTF_UNICODE
			mov [edi].__KEYBDINPUT.time,0
			mov [edi].__KEYBDINPUT.dwExtraInfo,0
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.type_,INPUT_KEYBOARD
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.wVk,0
			mov ax,WCHAR ptr [esi+ebx*2]
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.wScan,ax
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.dwFlags,KEYEVENTF_KEYUP
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.time,0
			mov [edi+SIZEOF __KEYBDINPUT].__KEYBDINPUT.dwExtraInfo,0
		.endif
		add cc2,2
		add edi,2*SIZEOF __KEYBDINPUT
		lea ebx,[ebx+1]
	.endw
	pop edi
	invoke SendInput,cc2,edi,SIZEOF __KEYBDINPUT
	free edi
	
	ret
	
wszSendInput endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL rect:RECT
LOCAL lvc:LV_COLUMN
LOCAL lvi:LVITEM
LOCAL wsz[256]:WCHAR
LOCAL pt:POINT
LOCAL dwThreadID:DWORD
LOCAL kbinp[2]:__KEYBDINPUT
LOCAL hWndDest:HWND

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		invoke ChangeClipboardChain,hWnd,rv(GetWindowLong,hWnd,WND_DATA.hNextWnd)
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hLV) 
		mov esi,rv(SendMessage,ebx,LVM_GETITEMCOUNT,0,0)
		xor edi,edi
		.while edi < esi
			mov lvi.imask,LVIF_PARAM
			mov lvi.iItem,edi
			mov lvi.iSubItem,0
			mov lvi.lParam,0
			invoke SendMessage,ebx,LVM_GETITEM,0,ADDR lvi
			.if lvi.lParam
				mov ebx,lvi.lParam
				.if [ebx].CLIP_DATA.pData
					free [ebx].CLIP_DATA.pData
				.endif
			.endif
			lea edi,[edi+1]
		.endw
	.elseif uMsg == WM_CREATE
		invoke GetClientRect,hWnd,ADDR rect
		mov ebx,rv(CreateWindowEx,0,"SysListView32",0,WS_CHILD or WS_VISIBLE or LVS_REPORT,0,0,rect.right,rect.bottom,hWnd,0,hInstance,0)
		invoke SetWindowLong,hWnd,WND_DATA.hLV,ebx
		
		invoke RtlZeroMemory,ADDR lvc,SIZEOF lvc
		mov lvc.imask,LVCF_TEXT	or LVCF_WIDTH
		mov lvc.lx,400
		mov lvc.pszText,chr$("Text")
		invoke SendMessage,ebx,LVM_INSERTCOLUMN,1,ADDR lvc
		invoke SetWindowLong,hWnd,WND_DATA.hNextWnd,rv(SetClipboardViewer,hWnd)
	.elseif uMsg ==  WM_CHANGECBCHAIN
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hNextWnd)
		.if ebx != wParam
			invoke SendMessage,ebx,uMsg,wParam,lParam
		.else
			invoke SetWindowLong,hWnd,WND_DATA.hNextWnd,lParam
		.endif
	.elseif uMsg == WM_DRAWCLIPBOARD
		invoke OpenClipboard,hWnd
		.if !rv(GetWindowLong,hWnd,WND_DATA.bLock)
			.if rv(GetClipboardData,CF_UNICODETEXT)
				mov ebx,eax
				push rv(GlobalSize,ebx)
				mov edi,alloc(eax)
				mov esi,rv(GlobalLock,ebx)
				mov ecx,DWORD ptr [esp]
				invoke MemCopy,esi,edi,ecx
				invoke GlobalUnlock,ebx
				pop ecx
				invoke PostMessage,hWnd,WM_ADD_DATA,edi,ecx
			.endif
		.endif
		invoke CloseClipboard
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hNextWnd)
		invoke SendMessage,ebx,uMsg,wParam,lParam	
	.elseif uMsg == WM_ADD_DATA
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hLV)
		
		mov edi,alloc(SIZEOF CLIP_DATA)
		
		m2m [edi].CLIP_DATA.pData,wParam
		m2m [edi].CLIP_DATA.cb,lParam
		mov lvi.imask,LVIF_TEXT	or LVIF_PARAM
		mov lvi.iItem,0
		mov lvi.iSubItem,0
		mov lvi.lParam,edi
		lea eax,wsz
		mov lvi.pszText,eax
		
		invoke wszStrPreview,wParam,lParam,ADDR wsz,LENGTHOF wsz
		invoke SendMessage,ebx,LVM_INSERTITEMW,0,ADDR lvi
	.elseif uMsg == WM_NOTIFY
		mov esi,lParam
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hLV)
		.if [esi].NMHDR.hwndFrom == ebx
			.if [esi].NM_LISTVIEW.hdr.code == LVN_BEGINDRAG
				invoke SetCapture,hWnd
				invoke SetWindowLong,hWnd,WND_DATA.DaD,1
				invoke SetWindowLong,hWnd,WND_DATA.DaD_iItem,[esi].NM_LISTVIEW.iItem
			.endif
		.endif
	.elseif uMsg == WM_LBUTTONUP
		.if rv(GetWindowLong,hWnd,WND_DATA.DaD)
			invoke ReleaseCapture			
			invoke SetWindowLong,hWnd,WND_DATA.DaD,0
			invoke GetCursorPos,ADDR pt
			.if rv(WindowFromPoint,pt.x,pt.y)
				mov esi,eax
				invoke ScreenToClient,esi,ADDR pt
				.if rv(ChildWindowFromPointEx,esi,pt.x,pt.y,CWP_SKIPINVISIBLE or CWP_SKIPTRANSPARENT)
					mov esi,eax
				.endif
				mov hWndDest,esi

				invoke SetWindowLong,hWnd,WND_DATA.bLock,1
				invoke OpenClipboard,hWnd
				invoke EmptyClipboard
				
				mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hLV)
				mov lvi.imask,LVIF_PARAM
				mov lvi.iItem,rv(GetWindowLong,hWnd,WND_DATA.DaD_iItem)
				mov lvi.iSubItem,0
				mov lvi.lParam,0
				invoke SendMessage,ebx,LVM_GETITEM,0,ADDR lvi
				mov ebx,lvi.lParam
				mov esi,rv(GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,[ebx].CLIP_DATA.cb)
				mov edi,rv(GlobalLock,esi)
				invoke MemCopy,[ebx].CLIP_DATA.pData,edi,[ebx].CLIP_DATA.cb
				invoke GlobalUnlock,esi
				invoke SetClipboardData,CF_UNICODETEXT,esi				
				invoke CloseClipboard
				invoke SetWindowLong,hWnd,WND_DATA.bLock,0
				
				mov dwThreadID,rv(GetWindowThreadProcessId,hWndDest,0)
				invoke AttachThreadInput,rv(GetCurrentThreadId),dwThreadID,1
				invoke SetFocus,hWndDest
		
				mov wsz[0],0
				invoke GetClassName,hWndDest,ADDR wsz,SIZEOF wsz
				.if rv(szCmp,ADDR wsz,chr$("ConsoleWindowClass"))
					invoke SetForegroundWindow,hWndDest
					invoke wszSendInput,[ebx].CLIP_DATA.pData,[ebx].CLIP_DATA.cb
				.else	
					mov kbinp[0].type_,INPUT_KEYBOARD
					mov kbinp[0].wVk,VK_CONTROL
					invoke MapVirtualKey,VK_CONTROL,0
					mov kbinp[0].wScan,ax
					mov kbinp[0].dwFlags,0
					mov kbinp[0].time,0
					mov kbinp[0].dwExtraInfo,0
					mov kbinp[SIZEOF __KEYBDINPUT].type_,INPUT_KEYBOARD
					mov kbinp[SIZEOF __KEYBDINPUT].wVk,VK_V
					invoke MapVirtualKey,VK_V,0
					mov kbinp[SIZEOF __KEYBDINPUT].wScan,ax
					mov kbinp[SIZEOF __KEYBDINPUT].dwFlags,0
					mov kbinp[SIZEOF __KEYBDINPUT].time,0
					mov kbinp[SIZEOF __KEYBDINPUT].dwExtraInfo,0
					invoke SendInput,2,ADDR kbinp,SIZEOF __KEYBDINPUT
					
					mov kbinp[0].type_,INPUT_KEYBOARD
					mov kbinp[0].wVk,VK_CONTROL
					invoke MapVirtualKey,VK_CONTROL,0
					mov kbinp[0].wScan,ax
					mov kbinp[0].dwFlags,KEYEVENTF_KEYUP
					mov kbinp[0].time,0
					mov kbinp[0].dwExtraInfo,0
					mov kbinp[SIZEOF __KEYBDINPUT].type_,INPUT_KEYBOARD
					mov kbinp[SIZEOF __KEYBDINPUT].wVk,VK_V
					invoke MapVirtualKey,VK_V,0
					mov kbinp[SIZEOF __KEYBDINPUT].wScan,ax
					mov kbinp[SIZEOF __KEYBDINPUT].dwFlags,KEYEVENTF_KEYUP
					mov kbinp[SIZEOF __KEYBDINPUT].time,0
					mov kbinp[SIZEOF __KEYBDINPUT].dwExtraInfo,0
					invoke SendInput,2,ADDR kbinp,SIZEOF __KEYBDINPUT
				.endif
				invoke AttachThreadInput,rv(GetCurrentThreadId),dwThreadID,0
				
			.endif
		.endif
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
